<template>
  <el-dialog title="Send by email" :visible.sync="dialogVisible">
    <el-form :model="share">
      <el-form-item label="Email" prop="email">
        <el-input v-model="share.email" placeholder="foo@bar.baz" required></el-input>
      </el-form-item>
      
    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button @click="cancelForm()">Cancel</el-button>
      <el-button type="primary" @click="submitForm()">Share</el-button>
    </span>
  </el-dialog>
</template>

<script>
import gql from 'graphql-tag'

export default {
  data() {
    return {
      dialogVisible: true,
      share: {
        email: '',
        timeRange: 'overall'
      }
    }
  },

  methods: {
    formSubmit() {
      this.$apollo.mutate({
        mutation: gql`mutation ($share: ShareInput!) {
          share(share: $share) {
            success
            message
            errors { field message }
          }
        }`,
        variables: { share: this.$data.share },
        update: (store, { data: { share } }) => {
          if(share.success) {
            this.$msgbox({
              type: 'success',
              message: 'Email sended successfully',
              callback: action => {
                this.$data.dialogVisible = false
                this.$router.push('/')
              }
            })
          }
          else
            this.$message.error('Failed to send email')
        }
      })
    },
    cancelForm() {
      this.$data.dialogVisible = false
      this.$router.push('/')
    }
  }
}
</script>
